#ifndef __NLIBRARY_H__
#define __NLIBRARY_H__



#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#ifdef _WIN32
#include <winsock2.h>
#else
	#include <netinet/in.h>
	#include <sys/socket.h>
	#include <sys/wait.h>
	#include <arpa/inet.h>
	#include <unistd.h>
#endif

#ifndef _WIN32
typedef unsigned int		SOCKET;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned int        UINT;
#endif

#ifndef INVALID_SOCKET
#define INVALID_SOCKET		(SOCKET)(~0)
#endif
#ifndef SOCKET_ERROR
#define SOCKET_ERROR		(-1)
#endif





#define UDP_PORT			12345
#define MAX_USER_NAME		64				/// ȸ. ּ, Ǵ user@domain  Ѵ.
#define	MAX_UDP_BUFFER		65000			///
#define MAX_CONNECTION		2048			///   


#define WM_SOCKETEVENT		WM_APP + 1000	///








/// Ŷ Ǻ
namespace packetid {
	enum {
		/// TCP Ŷ
		TCP,
		/// UDP Ŷ
		UDP
	};
}

/// Ŷ ÷
/// (Ŷ ü  )
namespace packetflag {
	enum {
		FILE,
		FOLDER,
		BYE,
		MEMBERS,
		FIND,
		LIST,
		NAME
	};
}


///  ť ÷
/// ( ť  ۾ ϱ  )
namespace sendqueue
{
	enum {
		CONNECT,
		DISCONNECT,
		FIND
	};
}






#define PACKET_DATA_SIZE	4096
/**
	͸  Ŷ 
*/

typedef struct _PACKET_DATA
{
	_PACKET_DATA()
	{
		memset(this, 0, sizeof(_PACKET_DATA));
	}
    WORD	nID;		// Ŷ ȣ
    BYTE	nFlag;		// Ŷ Command
    BYTE	nType;		// Ŷ Ÿ ( Ŷ or  Ŷ)
	WORD	nChk;		// Ἲ üũ
    WORD	nDataLen;	// Ŷ ũ
    BYTE	nData[PACKET_DATA_SIZE]; // Ŷ 

} PACKET_DATA;





/**
 *  ۼ Ŷ .
 * packetflag  شϴ  /ϱ ؼ 
 * @see packetflag
 */
struct PACKETHEADER
{
	int nID;
	/// Ŷ ÷ @see packetflag
	int nFlag;
	///    ̸ 
	int nDataLen;
};





/**
 * Ŭ̾Ʈ ,  ð, Ÿ
 */
struct CLIENTINFO
{
	/// Ŭ̾Ʈ ּ
	sockaddr_in		addr;
	/// Unix Time Stamp
	UINT			stamp;
};



/**
 *  ť
 * (ҹ sendqueue  ӽ̴̽.)
 */
struct SENDQUEUE
{
	///@see sendqueue
	int		nFlag;
	char	*pData;
	int		nDataLen;
};






/**
 * Ʈ ̺귯  Ŭ.
 *  Ŭ  ü ɸ  ִ.
 *  ɰ  ΰ   Ŭ Ȯؼ ٽ .
 */
class NLSocket {
public:
	NLSocket();
	~NLSocket();
	int		Init();
	int		Clean();
	int		Create( int af, int type, int protocol );
	int		Bind( int port );
	int		Listen( int pending );
	SOCKET	Accept( );

	BOOL	Attach( SOCKET new_socket );
	BOOL	ChkErr();

	int		Recv( char *buf, int len, int *received = NULL );
	int		Send( char *buf, int len );
	int		Close();

private:
	SOCKET	m_socket;
	sockaddr_in addr;
};


#endif
