/**
@note	ws2_32.lib is needed on VS
*/


#include "nlibrary.h"


///@todo	ʱȭ ȭ 
NLSocket::NLSocket()
{
	m_socket	= INVALID_SOCKET;

}

//
///@note Clean() Լ α׷   ȣؾѴ. ⼭ ȣϸ ȵȴ.
NLSocket::~NLSocket()
{
	Close();
}




/**
	 ϱ  ̺귯(DLL ε ) ʱȭѴ.
@note н ȯ濡  ۾ ʿ .

@return same as WSAStartup
*/
int NLSocket::Init()
{
#ifdef _WIN32
	/// ι  ʵ Ѵ.
	static BOOL bDone = false;
	if ( bDone ) return true;

	WORD	wVersionRequested;
	WSADATA	wsaData;
	int		nError;

	wVersionRequested	= MAKEWORD( 2, 2 );
	nError				= WSAStartup( wVersionRequested, &wsaData );

	if ( nError ) {
		// error
	}

	bDone = true;
	return nError;
#else
	return 0;
#endif

}


/*
	 ȯ濡 ȣѴ.

@note	 Լ  ̺귯 ü ϹǷ,
		Ŭ̾Ʈ  ϳ ݾҴٰ ؼ  Լ ȣϸ ȵȴ.
		׸  Լ Ư ü ѹ ȣϸȴ.
@return	same as WSACleanup
*/
int NLSocket::Clean()
{
	int rc;
#ifdef _WIN32
	rc	= WSACleanup();
#else
	rc	= 0;
#endif
	return rc;
}



///@return  ũ
int NLSocket::Create( int af, int type, int protocol )
{
#ifdef _WIN32
	Init();
#endif

	m_socket	= socket( af, type, protocol );
	return m_socket;
}

///@todo IP-Address  ޾Ƽ ε   ֵ
///@return same as bind()
int NLSocket::Bind( int port )
{
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	addr.sin_addr.s_addr = INADDR_ANY;
	memset( addr.sin_zero, 0, sizeof( addr ) );

	return bind( m_socket, (sockaddr *) &addr, sizeof ( addr ) );
}


int NLSocket::Listen( int pending )
{
	return listen( m_socket, pending );
}


/**
 * @return same as accept
 */
SOCKET NLSocket::Accept( )
{
	return accept( m_socket, NULL, NULL );
}


/**
 *   ܺο   Ѵ.
 * , Attach   ȿ ̾ϸ,
 * Attach Ǵ ü   Ǿ ־Ѵ.
 * @return ̸ 0, ƴϸ 1
 */
BOOL	NLSocket::Attach( SOCKET new_socket )
{
	if ( new_socket == INVALID_SOCKET )
		return true;

	m_socket	= new_socket;
	return false;
}




/**
 *   Ѵ.
 *       ְ    ִ.
 *   , ǥ  Ʈ  ޼ ǥѴ.
 * @return   false,   true
 * @ex SOCKET socket = server->Accept( ); server->ChkErr();
 */
BOOL	NLSocket::ChkErr()
{
#ifdef _WIN32
	int nError	= WSAGetLastError();

	if ( nError == 0 ) return false;
	switch ( nError )
	{
	case WSANOTINITIALISED	:
		fprintf( stderr, "[%d] WSAStartup Լ ȣ ʾҽϴ.", nError );
		break;
	case WSAENETDOWN		:
		fprintf( stderr, "[%d] Ʈũ ٿ", nError );
		break;
	case WSAEFAULT			:
		fprintf( stderr, "[%d] addrlen ڰ ", nError );
		break;
	case WSAEINTR			:
		fprintf( stderr, "[%d] ƮƮ  ߴ", nError );
		break;
	case WSAEINPROGRESS		:
		fprintf( stderr, "[%d] ŷ   1.1   ̰ų    ڰ ݹ Լ ó", nError );
		break;
	case WSAEINVAL			:
		fprintf( stderr, "[%d] accept()  listen()  ", nError );
		break;
	case WSAEMFILE			:
		fprintf( stderr, "[%d]   ť   ,   ִ  ĺڰ ", nError );
		break;
	case WSAENOBUFS			:
		fprintf( stderr, "[%d]  ", nError );
		break;
	case WSAENOTSOCK		:
		fprintf( stderr, "[%d]  ĺڰ ƴ", nError );
		break;
	case WSAEOPNOTSUPP			:
		fprintf( stderr, "[%d] Ǵ   񽺸 ϴ  ƴ", nError );
		break;
	case WSAEWOULDBLOCK			:
		fprintf( stderr, "[%d]  ͺŷ   ε, ť ޾Ƶ   ʽϴ.", nError );
		break;


	}


	WSASetLastError( 0 );
#endif
	return false;
}



/**

  ͸ о δ.

  @param char *buf
	޸ ͸ ޾Ƽ  Ϳ ͸ Ѵ.

  @param int len
	͸ о  .   ۾ƾѴ.

  @param int *received
      ̸ Ѵ.
	NULL  ԷµǸ    ʴ´.
	, ׷ Ǹ ۽  Ḧ   .

  @note   NULL ڸ ߰ ʴ´.
  @note ͸  ϰ, ۽  , *received  0 ȴ.
	, ͸  ߰,  ߴ ˷,   NULL  Էؼ ȵȴ.
	  Ű  Ḧ  ٸ üũ   ׷ ص ȴ.
  @return ̸ 0, ƴϸ 0 ƴ 

*/
int		NLSocket::Recv( char *buf, int len, int *received )
{

	int nBytes;
	nBytes = recv( m_socket, buf, len, 0 );
	if ( nBytes == SOCKET_ERROR ) {
		return nBytes;	// SOCKET_ERROR  
	}
	else if ( nBytes == 0 ) {
		//  
	}

	*received = nBytes;
	return 0;
}

///@return same as send
int		NLSocket::Send( char *buf, int len )
{
	return send( m_socket, buf, len, 0 );
}


int NLSocket::Close()
{
	if ( m_socket != INVALID_SOCKET) {
#ifdef _WIN32
		closesocket( m_socket );
#else
		close( m_socket );
#endif
		m_socket = INVALID_SOCKET;
	}
	return 0;
}
